Index: code/branches/network/src/network/PacketDecoder.cc
===================================================================
--- code/branches/network/src/network/PacketDecoder.cc	(revision 217)
+++ code/branches/network/src/network/PacketDecoder.cc	(revision 223)
@@ -1,2 +1,10 @@
+/*
+ * Class contains functions to determine and decode incomming packages
+ * 
+ * Autor: Dumeni Manatschal
+ * 
+*/
+
+
 #include "enet/enet.h"
 #include "PacketManager.h"
@@ -8,4 +16,6 @@
 PacketDecoder::PacketDecoder(){}
 
+//call this function out of an instance of PacketDecoder
+//it will determine the type id and call the right decode function
 bool PacketDecoder::elaborate( ENetPacket* packet, int clientId )
 {
@@ -33,4 +43,6 @@
 	return false;
 }
+
+//following are the decode functions for the data of the packets
 
 void PacketDecoder::acknowledgement( ENetPacket* packet )
@@ -64,16 +76,7 @@
 	printChat( chatting );
 }
-/*
-void PacketDecoder::printPeer( ENetPeer* peer )
-{
-	cout << "number of chanels:   " << peer->channelCount << endl;
-	cout << "incomming bandwidth: " << peer->incomingBandwidth << endl;
-	cout << "outgoing bandwidth:  " << peer->outgoingBandwidth << endl;
-	cout << "peer id:             " << peer->sessionID << endl;
-	cout << "outgoing peer id:    " << peer->outgoingPeerID << endl;
-	cout << "incomming peer id:   " << peer->incomingPeerID << endl;
-	cout << "state of peer:       " << peer->state << endl;
-}
-*/
+
+//these are some print functions for test stuff
+
 void PacketDecoder::printAck( ack* data )
 {
Index: code/branches/network/src/network/PacketGenerator.cc
===================================================================
--- code/branches/network/src/network/PacketGenerator.cc	(revision 217)
+++ code/branches/network/src/network/PacketGenerator.cc	(revision 223)
@@ -1,2 +1,9 @@
+/*
+ *Class generates packets that can be send by enet
+ * 
+ * Autor: Dumeni Manatschal
+ *  
+*/
+
 #include "PacketManager.h"
 #include "enet/enet.h"
@@ -11,4 +18,6 @@
 PacketGenerator::PacketGenerator() {}
 
+//following functions create a packet in form of bytestream
+
 ENetPacket* PacketGenerator::acknowledgement( int state, int reliable )
 {
@@ -22,5 +31,5 @@
 	return packet;
 }
-
+/*### mouseupdates */
 ENetPacket* PacketGenerator::mousem( double x, double y, int reliable )
 {
@@ -35,5 +44,5 @@
 	return packet;
 }
-
+/*### keystrikes updates */
 ENetPacket* PacketGenerator::keystrike( char press, int reliable )
 {
@@ -47,9 +56,10 @@
 	return packet;
 }
-
+/*### chat messages packet */
 ENetPacket* PacketGenerator::chatMessage( const char* message, int reliable )
 {
 	int* trans = new int[sizeof(int) + strlen(message) + 1];
 	*trans = CHAT;
+	//be carefull here, don't forget to allocate the space before using it ;-)
 	memcpy( &trans[1], (const void*)message, strlen( message ) + 1);
 	ENetPacket *packet = enet_packet_create( trans , sizeof( int ) + strlen( message ) + 1, reliable );
Index: code/branches/network/src/network/PacketManager.h
===================================================================
--- code/branches/network/src/network/PacketManager.h	(revision 217)
+++ code/branches/network/src/network/PacketManager.h	(revision 223)
@@ -4,4 +4,5 @@
 #include <enet/enet.h>
 
+//enum netowk generaly used to set the type ID of a packet
 namespace network
 {
@@ -13,8 +14,15 @@
 };
 
+/*
+ * class to generate packets
+ * 
+ * Autor: Dumeni Manatschal
+ * 
+*/ 
 class PacketGenerator
 {
 public:
 	PacketGenerator();
+	//call one of this functions out of an instance of PacketGenerator to create a packet
 	ENetPacket* acknowledgement( int state, int reliable = ENET_PACKET_FLAG_RELIABLE );
 	ENetPacket* mousem( double x, double y, int reliable = ENET_PACKET_FLAG_RELIABLE );
@@ -22,4 +30,5 @@
 	ENetPacket* chatMessage( const char* message, int reliable = ENET_PACKET_FLAG_RELIABLE );
 private:
+	//used to set the bytes in the right order
 	struct ack {
 		int id;
@@ -39,8 +48,15 @@
 };
 
+/*
+ * class used to decode incoming packets
+ * 
+ * Autor: Dumeni Manatschal
+ * 
+*/
 class PacketDecoder
 {
 public:
 	PacketDecoder();
+	//call this function to decode, it calls the right decoding function below
 	bool elaborate( ENetPacket* packet, int clientId );
 private:
@@ -60,4 +76,6 @@
 		char press;
 	};
+	//only in this class, not PacketGenerator, used as pattern to put incoming
+	//bytes inside
 	struct chat {
 		int id;