Index: code/branches/network/src/network/Client.cc
===================================================================
--- code/branches/network/src/network/Client.cc	(revision 229)
+++ code/branches/network/src/network/Client.cc	(revision 230)
@@ -5,5 +5,5 @@
 //
 //
-// Author:  <>, (C) 2007
+// Author:  Oliver Scheuss, (C) 2007
 //
 // Copyright: See COPYING file that comes with this distribution
Index: code/branches/network/src/network/Client.h
===================================================================
--- code/branches/network/src/network/Client.h	(revision 229)
+++ code/branches/network/src/network/Client.h	(revision 230)
@@ -5,5 +5,5 @@
 //
 //
-// Author:  <>, (C) 2007
+// Author:  Oliver Scheuss, (C) 2007
 //
 // Copyright: See COPYING file that comes with this distribution
Index: code/branches/network/src/network/ConnectionManager.cc
===================================================================
--- code/branches/network/src/network/ConnectionManager.cc	(revision 229)
+++ code/branches/network/src/network/ConnectionManager.cc	(revision 230)
@@ -27,11 +27,17 @@
   }
   
-  ConnectionManager::ConnectionManager(int port, int address){
+  ConnectionManager::ConnectionManager(int port, std::string address){
     quit=false;
     client=NULL;
-    bindAddress.host = address;
+    enet_address_set_host (& bindAddress, address.c_str());
     bindAddress.port = NETWORK_PORT;
   }
   
+  ConnectionManager::ConnectionManager(int port, const char *address){
+    quit=false;
+    client=NULL;
+    enet_address_set_host (& bindAddress, address);
+    bindAddress.port = NETWORK_PORT;
+  }
   
   ENetPacket *ConnectionManager::getPacket(ENetAddress &address){
Index: code/branches/network/src/network/ConnectionManager.h
===================================================================
--- code/branches/network/src/network/ConnectionManager.h	(revision 229)
+++ code/branches/network/src/network/ConnectionManager.h	(revision 230)
@@ -14,4 +14,5 @@
 
 #include <iostream>
+#include <string>
 // enet library for networking support
 #include <enet/enet.h>
@@ -44,5 +45,6 @@
     public:
     ConnectionManager();
-    ConnectionManager(int port, int address);
+    ConnectionManager(int port, const char *address);
+    ConnectionManager(int port, std::string address);
     ENetPacket *getPacket(ENetAddress &address); // thread1
     // check wheter the packet queue is empty
Index: code/branches/network/src/network/Makefile
===================================================================
--- code/branches/network/src/network/Makefile	(revision 229)
+++ code/branches/network/src/network/Makefile	(revision 230)
@@ -25,4 +25,6 @@
 Client.o: Client.cc
 	${CC} -c Client.cc -g ${INC}
+Server.o: Server.cc
+	${CC} -c Server.cc -g ${INC}
 
 clean:
Index: code/branches/network/src/network/Server.cc
===================================================================
--- code/branches/network/src/network/Server.cc	(revision 230)
+++ code/branches/network/src/network/Server.cc	(revision 230)
@@ -0,0 +1,53 @@
+//
+// C++ Implementation: Server
+//
+// Description: 
+//
+//
+// Author:  Oliver Scheuss, (C) 2007
+//
+// Copyright: See COPYING file that comes with this distribution
+//
+//
+
+
+#include "network/Server.h"
+
+namespace network{
+  
+  /**
+   * Constructor for default values (bindaddress is set to ENET_HOST_ANY
+   * 
+   */
+  Server::Server(){
+    
+    
+  }
+  
+  /**
+   * Constructor
+   * @param port Port to listen on
+   * @param bindAddress Address to listen on
+   */
+  Server::Server(int port, std::string bindAddress) : connection(port, bindAddress){
+    
+    
+  }
+  
+  /**
+   * Constructor
+   * @param port Port to listen on
+   * @param bindAddress Address to listen on
+   */
+  Server::Server(int port, const char *bindAddress) : connection(port, bindAddress){
+    
+    
+    
+    
+  }
+  
+  
+  
+  
+  
+}
Index: code/branches/network/src/network/Server.h
===================================================================
--- code/branches/network/src/network/Server.h	(revision 230)
+++ code/branches/network/src/network/Server.h	(revision 230)
@@ -0,0 +1,51 @@
+//
+// C++ Interface: Server
+//
+// Description: 
+//
+//
+// Author:  Oliver Scheuss, (C) 2007
+//
+// Copyright: See COPYING file that comes with this distribution
+//
+//
+
+#ifndef NETWORK_SERVER_H
+#define NETWORK_SERVER_H
+
+#include <string>
+
+#include "network/ConnectionManager.h"
+#include "network/PacketManager.h"
+
+
+namespace network{
+  
+  /**
+   * This class is the root class of the network module for a server.
+   * It implements all functions necessary for a Server
+   */
+  class Server : PacketDecoder{
+    public:
+    Server();
+    Server(int port, std::string bindAddress);
+    Server(int port, const char *bindAddress);
+    
+    private:
+    ConnectionManager connection;
+    
+    
+    
+    
+    
+    
+    
+  };
+  
+  
+  
+  
+  
+}
+
+#endif
Index: code/branches/network/src/network/Synchronisable.cc
===================================================================
--- code/branches/network/src/network/Synchronisable.cc	(revision 230)
+++ code/branches/network/src/network/Synchronisable.cc	(revision 230)
@@ -0,0 +1,26 @@
+//
+// C++ Implementation: synchronisable
+//
+// Description: 
+//
+//
+// Author:  Oliver Scheuss, (C) 2007
+//
+// Copyright: See COPYING file that comes with this distribution
+//
+//
+#include "network/Synchronisable.h"
+
+namespace network {
+
+Synchronisable::Synchronisable()
+{
+}
+
+
+Synchronisable::~Synchronisable()
+{
+}
+
+
+}
Index: code/branches/network/src/network/Synchronisable.h
===================================================================
--- code/branches/network/src/network/Synchronisable.h	(revision 230)
+++ code/branches/network/src/network/Synchronisable.h	(revision 230)
@@ -0,0 +1,32 @@
+//
+// C++ Interface: synchronisable
+//
+// Description: 
+//
+//
+// Author:  Oliver Scheuss, (C) 2007
+//
+// Copyright: See COPYING file that comes with this distribution
+//
+//
+#ifndef NETWORKSYNCHRONISABLE_H
+#define NETWORKSYNCHRONISABLE_H
+
+namespace network {
+
+/**
+ * This class is the base class of all the Objects in the universe that need to be synchronised over the network
+ * Every class, that inherits from this class has to link the DATA THAT NEEDS TO BE SYNCHRONISED into the linked list. Additionally it also has to provide a Constructor, that takes exactly the variables in this linked list.
+ * @author Oliver Scheuss
+*/
+class Synchronisable{
+public:
+    Synchronisable();
+
+    ~Synchronisable();
+
+};
+
+}
+
+#endif