Index: code/branches/objecthierarchie/src/Identifier.cc
===================================================================
--- code/branches/objecthierarchie/src/Identifier.cc	(revision 225)
+++ code/branches/objecthierarchie/src/Identifier.cc	(revision 231)
@@ -20,5 +20,7 @@
     void Identifier::initialize(IdentifierList* parents)
     {
+#if HIERARCHY_VERBOSE
         std::cout << "*** Initialize " << this->name_ << "-Singleton.\n";
+#endif
         if (parents)
         {
Index: code/branches/objecthierarchie/src/Identifier.h
===================================================================
--- code/branches/objecthierarchie/src/Identifier.h	(revision 225)
+++ code/branches/objecthierarchie/src/Identifier.h	(revision 231)
@@ -6,19 +6,8 @@
 #include "IdentifierList.h"
 #include "ObjectList.h"
-//#include "OrxonoxClass.h"
 #include "Factory.h"
 
-// DONE AND TESTED:
-// - build class hierarchy
-// - isA, isChildOf, ...
-// - insert into class-lists
-// - ClassIdentifier
-// - BaseIdentifier
-// - Factory
-
-// IN WORK:
-
-// TO DO:
-// - iterate through lists
+#define HIERARCHY_VERBOSE false
+
 
 namespace orxonox
@@ -63,6 +52,19 @@
             void initialize(IdentifierList* parents);
 
-            static void startCreatingHierarchy() { hierarchyCreatingCounter_s++; std::cout << "*** Increased Hierarchy-Creating-Counter to " << hierarchyCreatingCounter_s << "\n"; }
-            static void stopCreatingHierarchy() { hierarchyCreatingCounter_s--; std::cout << "*** Decreased Hierarchy-Creating-Counter to " << hierarchyCreatingCounter_s << "\n"; }
+            static void startCreatingHierarchy()
+            {
+                hierarchyCreatingCounter_s++;
+#if HIERARCHY_VERBOSE
+                std::cout << "*** Increased Hierarchy-Creating-Counter to " << hierarchyCreatingCounter_s << "\n";
+#endif
+            }
+
+            static void stopCreatingHierarchy()
+            {
+                hierarchyCreatingCounter_s--;
+#if HIERARCHY_VERBOSE
+                std::cout << "*** Decreased Hierarchy-Creating-Counter to " << hierarchyCreatingCounter_s << "\n";
+#endif
+            }
 
             IdentifierList directParents_;
@@ -144,8 +146,12 @@
     ClassIdentifier<T>* ClassIdentifier<T>::registerClass(IdentifierList* parents, std::string name, bool bRootClass, bool bIsAbstractClass)
     {
+#if HIERARCHY_VERBOSE
         std::cout << "*** Register Class in " << name << "-Singleton.\n";
+#endif
         if (!pointer_s)
         {
+#if HIERARCHY_VERBOSE
             std::cout << "*** Register Class in " << name << "-Singleton -> Create Singleton.\n";
+#endif
             if (parents || bRootClass)
             {
@@ -173,8 +179,12 @@
     ClassIdentifier<T>* ClassIdentifier<T>::getIdentifier()
     {
+#if HIERARCHY_VERBOSE
 //        std::cout << "*** Get Identifier.\n";
+#endif
         if (!pointer_s)
         {
+#if HIERARCHY_VERBOSE
             std::cout << "*** Get Identifier -> Create Class\n";
+#endif
             Identifier::startCreatingHierarchy();
             T* temp = new T();
@@ -189,5 +199,7 @@
     void ClassIdentifier<T>::addObject(T* object)
     {
+#if HIERARCHY_VERBOSE
         std::cout << "*** Added object to " << ClassIdentifier<T>::getIdentifier()->getName() << "-list.\n";
+#endif
         ClassIdentifier<T>::getIdentifier()->objects_s.add(object);
     }
@@ -198,8 +210,10 @@
         bool bIterateForwards = !Identifier::isCreatingHierarchy();
 
+#if HIERARCHY_VERBOSE
         if (bIterateForwards)
             std::cout << "*** Removed object from " << this->name_ << "-list, iterating forwards.\n";
         else
             std::cout << "*** Removed object from " << this->name_ << "-list, iterating backwards.\n";
+#endif
 
         this->objects_s.remove(object, bIterateForwards);
Index: code/branches/objecthierarchie/src/IdentifierIncludes.h
===================================================================
--- code/branches/objecthierarchie/src/IdentifierIncludes.h	(revision 225)
+++ code/branches/objecthierarchie/src/IdentifierIncludes.h	(revision 231)
@@ -15,11 +15,21 @@
     ClassIdentifier<ClassName>::addObject(this)
 
+#if HIERARCHY_VERBOSE
 #define registerRootObject(ClassName) \
     std::cout << "*** Register Root-Object: " << #ClassName << "\n"; \
     internRegisterRootObject(ClassName, false)
+#else
+#define registerRootObject(ClassName) \
+    internRegisterRootObject(ClassName, false)
+#endif
 
+#if HIERARCHY_VERBOSE
 #define registerAbstractRootObject(ClassName) \
     std::cout << "*** Register abstract Root-Object: " << #ClassName << "\n"; \
     internRegisterRootObject(ClassName, true)
+#else
+#define registerAbstractRootObject(ClassName) \
+    internRegisterRootObject(ClassName, true)
+#endif
 
 #define internRegisterObject(ClassName, bAbstract) \
@@ -29,11 +39,21 @@
     ClassIdentifier<ClassName>::addObject(this)
 
+#if HIERARCHY_VERBOSE
 #define registerObject(ClassName) \
     std::cout << "*** Register Object: " << #ClassName << "\n"; \
     internRegisterObject(ClassName, false)
+#else
+#define registerObject(ClassName) \
+    internRegisterObject(ClassName, false)
+#endif
 
+#if HIERARCHY_VERBOSE
 #define registerAbstractObject(ClassName) \
     std::cout << "*** Register abstract Object: " << #ClassName << "\n"; \
     internRegisterObject(ClassName, true)
+#else
+#define registerAbstractObject(ClassName) \
+    internRegisterObject(ClassName, true)
+#endif
 
 #define unregisterObject() \