Index: code/branches/objecthierarchie/src/BaseObject.h
===================================================================
--- code/branches/objecthierarchie/src/BaseObject.h	(revision 241)
+++ code/branches/objecthierarchie/src/BaseObject.h	(revision 242)
@@ -25,28 +25,28 @@
                 { this->getIdentifier()->isDirectParentOf(identifier); }
 
-            inline bool isA(const BaseIdentifier<class B>* identifier)
+            inline bool isA(const SubclassIdentifier<class B>* identifier)
                 { this->getIdentifier()->isA(identifier->getIdentifier()); }
-            inline bool isDirectlyA(const BaseIdentifier<class B>* identifier)
+            inline bool isDirectlyA(const SubclassIdentifier<class B>* identifier)
                 { this->getIdentifier()->isDirectlyA(identifier->getIdentifier()); }
-            inline bool isChildOf(const BaseIdentifier<class B>* identifier)
+            inline bool isChildOf(const SubclassIdentifier<class B>* identifier)
                 { this->getIdentifier()->isChildOf(identifier->getIdentifier()); }
-            inline bool isDirectChildOf(const BaseIdentifier<class B>* identifier)
+            inline bool isDirectChildOf(const SubclassIdentifier<class B>* identifier)
                 { this->getIdentifier()->isDirectChildOf(identifier->getIdentifier()); }
-            inline bool isParentOf(const BaseIdentifier<class B>* identifier)
+            inline bool isParentOf(const SubclassIdentifier<class B>* identifier)
                 { this->getIdentifier()->isParentOf(identifier->getIdentifier()); }
-            inline bool isDirectParentOf(const BaseIdentifier<class B>* identifier)
+            inline bool isDirectParentOf(const SubclassIdentifier<class B>* identifier)
                 { this->getIdentifier()->isDirectParentOf(identifier->getIdentifier()); }
 
-            inline bool isA(const BaseIdentifier<class B> identifier)
+            inline bool isA(const SubclassIdentifier<class B> identifier)
                 { this->getIdentifier()->isA(identifier.getIdentifier()); }
-            inline bool isDirectlyA(const BaseIdentifier<class B> identifier)
+            inline bool isDirectlyA(const SubclassIdentifier<class B> identifier)
                 { this->getIdentifier()->isDirectlyA(identifier.getIdentifier()); }
-            inline bool isChildOf(const BaseIdentifier<class B> identifier)
+            inline bool isChildOf(const SubclassIdentifier<class B> identifier)
                 { this->getIdentifier()->isChildOf(identifier.getIdentifier()); }
-            inline bool isDirectChildOf(const BaseIdentifier<class B> identifier)
+            inline bool isDirectChildOf(const SubclassIdentifier<class B> identifier)
                 { this->getIdentifier()->isDirectChildOf(identifier.getIdentifier()); }
-            inline bool isParentOf(const BaseIdentifier<class B> identifier)
+            inline bool isParentOf(const SubclassIdentifier<class B> identifier)
                 { this->getIdentifier()->isParentOf(identifier.getIdentifier()); }
-            inline bool isDirectParentOf(const BaseIdentifier<class B> identifier)
+            inline bool isDirectParentOf(const SubclassIdentifier<class B> identifier)
                 { this->getIdentifier()->isDirectParentOf(identifier.getIdentifier()); }
 
Index: code/branches/objecthierarchie/src/Identifier.h
===================================================================
--- code/branches/objecthierarchie/src/Identifier.h	(revision 241)
+++ code/branches/objecthierarchie/src/Identifier.h	(revision 242)
@@ -24,5 +24,5 @@
 
         template <class T>
-        friend class BaseIdentifier;
+        friend class SubclassIdentifier;
 
         public:
@@ -231,18 +231,18 @@
 
     // ###############################
-    // ###     BaseIdentifier      ###
+    // ###   SubclassIdentifier    ###
     // ###############################
     template <class B>
-    class BaseIdentifier
+    class SubclassIdentifier
     {
         public:
-            BaseIdentifier();
-
-            BaseIdentifier<B>& operator=(Identifier* identifier)
+            SubclassIdentifier();
+
+            SubclassIdentifier<B>& operator=(Identifier* identifier)
             {
                 if (!identifier->isA(ClassIdentifier<B>::getIdentifier()))
                 {
                     std::cout << "Error: Class " << identifier->getName() << " is not a " << ClassIdentifier<B>::getIdentifier()->getName() << "!\n";
-                    std::cout << "Error: BaseIdentifier<" << ClassIdentifier<B>::getIdentifier()->getName() << "> = Class(" << identifier->getName() << ") is forbidden.\n";
+                    std::cout << "Error: SubclassIdentifier<" << ClassIdentifier<B>::getIdentifier()->getName() << "> = Class(" << identifier->getName() << ") is forbidden.\n";
                     std::cout << "Aborting...\n";
                     abort();
@@ -307,5 +307,5 @@
 
     template <class B>
-    BaseIdentifier<B>::BaseIdentifier()
+    SubclassIdentifier<B>::SubclassIdentifier()
     {
         this->identifier_ = ClassIdentifier<B>::getIdentifier();
Index: code/branches/objecthierarchie/src/orxonox.cc
===================================================================
--- code/branches/objecthierarchie/src/orxonox.cc	(revision 241)
+++ code/branches/objecthierarchie/src/orxonox.cc	(revision 242)
@@ -441,8 +441,8 @@
         std::cout << "Test 7\n";
         std::cout << "1\n";
-        BaseIdentifier<A1B1> test7_01;
+        SubclassIdentifier<A1B1> test7_01;
         test7_01 = Class(A1B1C1);
 
-        BaseIdentifier<A1B1> test7_02;
+        SubclassIdentifier<A1B1> test7_02;
         test7_02 = Class(A1B1);
 
@@ -453,11 +453,11 @@
         std::cout << "2\n";
 
-        BaseIdentifier<A1B1> test7_03;
+        SubclassIdentifier<A1B1> test7_03;
         test7_03 = Class(A1);
 
-        BaseIdentifier<A1B1> test7_04;
+        SubclassIdentifier<A1B1> test7_04;
         test7_04 = Class(A1B2);
 
-        BaseIdentifier<A1B1> test7_05;
+        SubclassIdentifier<A1B1> test7_05;
         test7_05 = Class(A2);
 */
@@ -512,5 +512,5 @@
 
         std::cout << "\n3\n";
-        BaseIdentifier<A1> test9_04;
+        SubclassIdentifier<A1> test9_04;
         test9_04 = Class(A1B1C1);
         A1* test9_05 = test9_04.fabricate();
Index: code/branches/objecthierarchie/src/test1.h
===================================================================
--- code/branches/objecthierarchie/src/test1.h	(revision 241)
+++ code/branches/objecthierarchie/src/test1.h	(revision 242)
@@ -23,5 +23,5 @@
             Identifier* usefullClass1_;
             Identifier* usefullClass2_;
-            BaseIdentifier<Test3> usefullClass3_;
+            SubclassIdentifier<Test3> usefullClass3_;
 
     };
Index: code/branches/objecthierarchie/src/test2.h
===================================================================
--- code/branches/objecthierarchie/src/test2.h	(revision 241)
+++ code/branches/objecthierarchie/src/test2.h	(revision 242)
@@ -24,5 +24,5 @@
             Identifier* usefullClass1_;
             Identifier* usefullClass2_;
-            BaseIdentifier<Test3> usefullClass3_;
+            SubclassIdentifier<Test3> usefullClass3_;
 
     };